<!DOCTYPE html>
<html lang="fr">
<head>
<meta charset="utf-8"/>
<title>Git et Gitlab/Github</title>
<meta name="author" content="(Pierre Gambarotto)"/>
<style type="text/css">
.underline { text-decoration: underline; }
</style>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/css/reveal.css"/>

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/css/theme/white.css" id="theme"/>

<link rel="stylesheet" href="./local.css"/>

<!-- If the query includes 'print-pdf', include the PDF print sheet -->
<script>
    if( window.location.search.match( /print-pdf/gi ) ) {
        var link = document.createElement( 'link' );
        link.rel = 'stylesheet';
        link.type = 'text/css';
        link.href = 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/css/print/pdf.css';
        document.getElementsByTagName( 'head' )[0].appendChild( link );
    }
</script>
</head>
<body>
<div class="reveal">
<div class="slides">
<section id="sec-title-slide"><h1 class="title">Git et Gitlab/Github</h1><h2 class="author">Pierre Gambarotto</h2><p class="date">Created: 2019-04-15 Mon 09:59</p>
</section>



<section>
<section id="slide-orge305da9">
<h2 id="orge305da9">Séance 1 : découverte de git et de gitlab/github</h2>
<p>
Séance 2 : approfondissements, plus tard, si besoin
</p>

<ul>
<li>entre les 2: <b>beaucoup</b> de pratique</li>

</ul>

</section>
</section>
<section>
<section id="slide-orgebfbb7b">
<h2 id="orgebfbb7b">De la tromperie des acronymes : TATA !</h2>
<p>
<span class="underline">SCM</span>
</p>

<dl>
<dt>Source Code Management</dt><dd>gestion des fichiers source d'un projet</dd>
<dt>Software Configuration Management</dt><dd>gestion de configuration</dd>

</dl>

</section>
<section >

<p>
Il faut considérer les 2 idées:
</p>

<dl>
<dt>Gérer des versions</dt><dd>historiser les modifications des fichiers d'un projet</dd>
<dt>Gérer des configurations</dt><dd>donner un sens à un ensemble de fichiers à une
version spécifique</dd>

</dl>

</section>
<section id="slide-org7f202f7">
<h3 id="org7f202f7">Gérer des versions</h3>
<ul>
<li>stocker des versions différentes</li>
<li>décider de l'enregistrement d'une nouvelle version</li>
<li>retrouver une version spécifique</li>

</ul>


<div class="figure">
<p><img src="./images/file_version_1.png" alt="file_version_1.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/file_version_2.png" alt="file_version_2.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/file_version_3.png" alt="file_version_3.png" class="fragment fade-in current-visible" />
</p>
</div>

</section>
<section id="slide-orgdd04f16">
<h3 id="orgdd04f16">Gérer des configurations</h3>

<div class="figure">
<p><img src="./images/conf1.png" alt="conf1.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/conf2.png" alt="conf2.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/conf3.png" alt="conf3.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/conf4.png" alt="conf4.png" class="fragment fade-in current-visible" />
</p>
</div>



<div class="figure">
<p><img src="./images/conf5.png" alt="conf5.png" class="fragment fade-in current-visible" />
</p>
</div>





</section>
</section>
<section>
<section id="slide-org99b823f">
<h2 id="org99b823f">Git</h2>
<ul>
<li>SCM du noyau Linux</li>
<li>créé par Linus Torvalds</li>
<li>distribué: plusieurs machines 
<ul>
<li>toute copie contient l'entièreté de l'historique</li>
<li>synchroniser 2 copies qui ont divergé</li>

</ul></li>
<li>élément atomique de version: arborescence de fichiers !</li>

</ul>

<aside class="notes">
<p>
arborescence de fichiers VS historique au niveau fichier
</p>

</aside>

</section>
</section>
<section>
<section id="slide-org7b4553b">
<h2 id="org7b4553b">Terminologie dans git</h2>
<dl>
<dt>fichier/répertoire</dt><dd>normalement c'est bon :-)</dd>
<dt>arborescence</dt><dd>un ensemble de fichiers/répertoires avec un répertoire racine <i>root</i></dd>
<dt>commit</dt><dd>un instantané <i>snapshot</i> d'une arborescence de fichiers</dd>
<dt>historique</dt><dd>un arbre de <b>commit</b>, avec un <b>commit</b> initial</dd>
<dt>repository</dt><dd>dépôt en français, <i>repo</i> en abrégé, conteneur d'historiques.</dd>

</dl>

</section>
<section id="slide-org4bf6a99">
<h3 id="org4bf6a99">les 2 concepts majeurs de git</h3>
<ul>
<li>graphe de commits</li>
<li>3 espaces de gestions séparés</li>

</ul>
</section>
<section id="slide-org4a41529">
<h3 id="org4a41529">Graphe de commits</h3>
<aside class="notes">
<ol>
<li>un répertoire</li>
<li>git init</li>
<li>commit 1</li>
<li>commit 2</li>

</ol>

</aside>


<div class="figure">
<p><img src="./images/commit_graph1.png" alt="commit_graph1.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/commit_graph2.png" alt="commit_graph2.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/commit_graph3.png" alt="commit_graph3.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/commit_graph4.png" alt="commit_graph4.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/commit_graph5.png" alt="commit_graph5.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="./images/commit_graph6.png" alt="commit_graph6.png" class="fragment fade-in current-visible" />
</p>
</div>

</section>
<section id="slide-org40b9e2b">
<h3 id="org40b9e2b">Les 3 espaces de gestion de git</h3>

<div class="figure">
<p><img src="images/3_spaces1.png" alt="3_spaces1.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="images/3_spaces2.png" alt="3_spaces2.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="images/3_spaces3.png" alt="3_spaces3.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="images/3_spaces4.png" alt="3_spaces4.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="images/3_spaces5.png" alt="3_spaces5.png" class="fragment fade-in current-visible" />
</p>
</div>


<div class="figure">
<p><img src="images/3_spaces6.png" alt="3_spaces6.png" class="fragment fade-in current-visible" />
</p>
</div>

</section>
<section id="slide-orgf8ac25c">
<h3 id="orgf8ac25c">Les 3 espaces de gestion de git</h3>
<dl>
<dt>Working Copy</dt><dd>répertoire de travail, contenu géré avec vos outils habituels</dd>
<dt>Staging Area</dt><dd>ou <i>index</i>, zone de préparation du commit suivant</dd>
<dt>History</dt><dd>série de commits</dd>

</dl>

<p>
<b>Staging Area</b> et <b>History</b> sont stockés dans le répertoire <code>.git</code>.
</p>

</section>
</section>
<section>
<section id="slide-org00c09f6">
<h2 id="org00c09f6">Plan de la formation</h2>
<ol>
<li>Gérer un historique dans un dépôt</li>
<li>Gérer plusieurs historiques en // dans le même dépôt</li>
<li>Gérer plusieurs dépôts, les synchroniser</li>
<li>gitlab/github : interfaces web pour git et +</li>

</ol>

</section>
</section>
<section>
<section id="slide-orgf0867e4">
<h2 id="orgf0867e4">Installer git</h2>
<div class="org-src-container">

<pre  class="src src-shell">$ sudo apt-get install git
</pre>
</div>

</section>
</section>
<section>
<section id="slide-orgcd37a70">
<h2 id="orgcd37a70">Créer et configurer un dépôt</h2>
<div class="org-src-container">

<pre  class="src src-shell">$ mkdir fullgit
$ cd fullgit <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">or existing directory</span>
$ git init <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">creates .git</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">git init fullgit</span>
D&#233;p&#244;t Git vide initialis&#233; dans fullgit/.git/
</pre>
</div>

<p>
<code>man git-init</code>
</p>

<ul>
<li><b>working copy</b> : répertoire <code>fullgit</code></li>
<li><b>staging area</b> et <b>history</b>: répertoire <code>.git</code></li>

</ul>

</section>
<section id="slide-org7f81615">
<h3 id="org7f81615">repository = .git</h3>
<div class="org-src-container">

<pre  class="src src-shell">$<span style="color: #7590db;">tree</span> -a .
<span style="color: #4f97d7;">.</span>
&#9492;&#9472;&#9472; .git
    &#9500;&#9472;&#9472; branches
    &#9500;&#9472;&#9472; config
    &#9500;&#9472;&#9472; description
    &#9500;&#9472;&#9472; HEAD
    &#9500;&#9472;&#9472; hooks
    &#9500;&#9472;&#9472; info
    &#9474;&#160;&#160; &#9492;&#9472;&#9472; exclude
    &#9500;&#9472;&#9472; objects
    &#9474;&#160;&#160; &#9500;&#9472;&#9472; info
    &#9474;&#160;&#160; &#9492;&#9472;&#9472; pack
    &#9492;&#9472;&#9472; refs
        &#9500;&#9472;&#9472; heads
        &#9492;&#9472;&#9472; tags
</pre>
</div>

</section>
<section id="slide-org3294a70">
<h3 id="org3294a70">working copy</h3>
<p>
Le reste du répertoire constitue la copie de travail
</p>

<dl>
<dt>working copy</dt><dd>affichage des fichiers correspondant à une version de
l'historique stockée dans <code>.git</code></dd>

</dl>

<p>
Git va permettre de modifier la copie de travail à partir de l'historique.
</p>

</section>
<section id="slide-org1760cbe">
<h3 id="org1760cbe">Configuration</h3>
<dl>
<dt>Pour tous les dépôts</dt><dd><code>~/.gitconfig</code></dd>
<dt>Spécifique à un dépôt</dt><dd><code>repo/.git/config</code></dd>

</dl>

<p>
Pour éditer la configuration
</p>

<ul>
<li>direct dans un des fichiers ci-dessus</li>
<li><code>git config [--global] name value</code></li>
<li><code>man git-config</code></li>

</ul>

</section>
<section >
<div class="org-src-container">

<pre  class="src src-shell">$ git config --global user.name <span style="color: #2d9574;">"Pierre Gambarotto"</span>
$ git config --global user.email pierre.gambarotto@math.univ-toulouse.fr
$ git config --global color.ui auto
$ git config --list
user.name=Pierre Gambarotto
user.email=pierre.gambarotto@math.univ-toulouse.fr
color.ui=auto
</pre>
</div>

</section>
</section>
<section>
<section id="slide-org90aebbb">
<h2 id="org90aebbb">Cycle de travail de base</h2>
<ol>
<li>Gérer des fichiers dans le répertoire de travail: créer/modifier/supprimer</li>
<li>Afficher l'état du répertoire de travail par rapport à l'historique: <code>git status</code></li>
<li>Sélectionner les modifications à historiser : <code>git add file1 file2</code></li>
<li>Historiser = créer un commit : <code>git commit</code></li>

</ol>

</section>
<section id="slide-org2dba9a1">
<h3 id="org2dba9a1">You talk too much !</h3>
<ul>
<li><a href="tp_cycle_travail_base.html">plan de manipulation à suivre</a></li>

</ul>
<a href="https://asciinema.org/a/vltUXh5bSi9GXmK44FAYyxVw7" target="_blank"><img src="https://asciinema.org/a/vltUXh5bSi9GXmK44FAYyxVw7.svg" /></a>

</section>
<section id="slide-org95cb533">
<h3 id="org95cb533">Travailler sur des fichiers</h3>
<p>
Avec les outils habituels
</p>

<div class="org-src-container">

<pre  class="src src-shell">$<span style="color: #7590db;">cd</span> fullgit <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">.git exists, created by git init</span>
$<span style="color: #7590db;">echo</span> <span style="color: #2d9574;">'# formation git'</span> &gt; readme.md
$<span style="color: #7590db;">mkdir</span> part1
$<span style="color: #7590db;">echo</span> <span style="color: #2d9574;">'# D&#233;couverte de git'</span> &gt; part1/intro.md
</pre>
</div>

</section>
<section id="slide-org15feb95">
<h3 id="org15feb95">git status</h3>
<p>
Affiche l'état des fichiers par rapport à l'historique géré par git
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git status 
Sur la branche master

Validation initiale

Fichiers non suivis:
  <span style="color: #4f97d7;">(</span>utilisez <span style="color: #2d9574;">"git add &lt;fichier&gt;..."</span> pour inclure dans ce qui sera valid&#233;<span style="color: #4f97d7;">)</span>

  readme.md
  part1/

aucune modification ajout&#233;e &#224; la validation mais des fichiers non 
suivis sont pr&#233;sents <span style="color: #4f97d7;">(</span>utilisez <span style="color: #2d9574;">"git add"</span> pour les suivre<span style="color: #4f97d7;">)</span>
</pre>
</div>

<p>
Par défaut, les fichiers ne sont pas gérés par git
</p>

</section>
<section id="slide-orgf20f70d">
<h3 id="orgf20f70d">git add</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git add readme.md
$ git status
Sur la branche master

Validation initiale

Modifications qui seront valid&#233;es :
  <span style="color: #4f97d7;">(</span>utilisez <span style="color: #2d9574;">"git rm --cached &lt;fichier&gt;..."</span> pour d&#233;sindexer<span style="color: #4f97d7;">)</span>

  nouveau fichier&#160;: readme.md

Fichiers non suivis:
  <span style="color: #4f97d7;">(</span>utilisez <span style="color: #2d9574;">"git add &lt;fichier&gt;..."</span> pour inclure dans ce qui sera valid&#233;<span style="color: #4f97d7;">)</span>

  part1/
</pre>
</div>

<p>
<code>git add</code> demande à git de suivre les modifications sur un fichier.
</p>

<p>
<code>git add</code> prépare l'index de tous les fichiers à gérer dans le prochain commit.
</p>

</section>
<section id="slide-org4af013f">
<h3 id="org4af013f">Notion d'index</h3>
<p>
Git gère en interne un index des fichiers du répertoire courant sélectionnés
pour le prochain commit:
</p>

<p>
<code>.git/index</code>
</p>

<p>
Pour une idée du contenu de l'index:
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git ls-files --stage
</pre>
</div>
</section>
<section id="slide-orgf209dc3">
<h3 id="orgf209dc3">git commit</h3>
<dl>
<dt>commit</dt><dd>enregistrer une nouvelle version à partir de l'index courant dans le dépôt</dd>
<dt>version</dt><dd>état des fichiers suivis par git, défini dans l'index</dd>

</dl>

</section>
<section id="slide-org76a12f3">
<h3 id="org76a12f3">commit initial</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git commit -m <span style="color: #2d9574;">"initial version"</span>
<span style="color: #4f97d7;">[</span>master <span style="color: #bc6ec5;">(</span>commit racine<span style="color: #bc6ec5;">)</span> f3ac13e<span style="color: #4f97d7;">]</span> initial version
 <span style="color: #a45bad;">1</span> file changed, <span style="color: #a45bad;">1</span> insertion<span style="color: #4f97d7;">(</span>+<span style="color: #4f97d7;">)</span>
 create mode <span style="color: #a45bad;">100644</span> readme.md
$ git log
commit <span style="color: #a45bad;">99f1b708d262061bccb3c82af86e3169e6be893b</span>
Author: Pierre Gambarotto <a href="mailto:pierre.gambarotto%40enseeiht.fr">&lt;pierre.gambarotto@enseeiht.fr&gt;</a>
Date:   Wed Oct <span style="color: #a45bad;">25</span> <span style="color: #a45bad;">03:52:34</span> <span style="color: #a45bad;">2017</span> +0200

    initial version
</pre>
</div>

</section>
<section id="slide-orgc44e41c">
<h3 id="orgc44e41c">commit suivant</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ echo <span style="color: #2d9574;">"## Gestion de l'index"</span> &gt;&gt; readme.md
$ git status
$ echo <span style="color: #2d9574;">"nouveau fichier"</span> &gt; autre.md
$ git status
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">modifi&#233; (rouge, non s&#233;lectonn&#233; pour le commit): readme.md</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">non suivis : autre.md, travail.md</span>
$ git add readme.md
$ git status 
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">modifi&#233; (vert, s&#233;l&#233;ctionn&#233; pour lecommit): readme.md</span>
$ git add tautre.md
$ git status
$ git commit <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">without -m, open $EDITOR</span>
$ git log
commit f2fd6a8a7690b14b097db11043bd5cf93672039d
Author: Pierre Gambarotto <a href="mailto:pierre.gambarotto%40enseeiht.fr">&lt;pierre.gambarotto@enseeiht.fr&gt;</a>
Date:   Wed Oct <span style="color: #a45bad;">25</span> <span style="color: #a45bad;">04:08:35</span> <span style="color: #a45bad;">2017</span> +0200

    coomit

commit <span style="color: #a45bad;">99f1b708d262061bccb3c82af86e3169e6be893b</span>
Author: Pierre Gambarotto <a href="mailto:pierre.gambarotto%40enseeiht.fr">&lt;pierre.gambarotto@enseeiht.fr&gt;</a>
Date:   Wed Oct <span style="color: #a45bad;">25</span> <span style="color: #a45bad;">03:52:34</span> <span style="color: #a45bad;">2017</span> +0200

    initial version
</pre>
</div>

</section>
<section id="slide-org9ac4c27">
<h3 id="org9ac4c27">Résumé</h3>
<ol>
<li>modifier des fichiers: éditeur de texte ou autre outil classique</li>
<li>sélectionner des fichiers différents du commit précédent: 
<ul>
<li><code>git status</code> pour les voir</li>
<li><code>git add</code> ajoute les fichiers dans la zone de préparation du futur commit (index)</li>

</ul></li>
<li>commit: crée un nouvel état dans l'historique à partir de l'index courant,
vide la zone de préparation</li>

</ol>

</section>
<section id="slide-orgc2dc350">
<h3 id="orgc2dc350">En image</h3>

<div class="figure">
<p><img src="images/index_working_copy.png" alt="index_working_copy.png" />
</p>
</div>

</section>
</section>
<section>
<section id="slide-org4b258f6">
<h2 id="org4b258f6">Premier tp</h2>
<ul>
<li>Créez un dépôt git</li>
<li>Dans le fichier <code>1_repo_creation.md</code>, prenez des notes au format <a href="https://docs.gitlab.com/ee/user/markdown.html#standard-markdown">markdown</a> sur
les opérations nécessaires pour créer un dépôt git</li>

</ul>

<p>
Par exemple:
</p>

<div class="org-src-container">

<pre  class="src src-markdown"><span style="color: #686868;"># </span><span style="color: #4f97d7; font-size: 130%; font-weight: bold;">Repository creation</span>

<span style="color: #686868;">```</span><span style="color: #ce537a; font-weight: bold;">shell</span>
<span style="color: #a45bad;">git init /tmp/my_repo</span>
<span style="color: #a45bad;">cd /tmp/my_repo</span>
<span style="color: #a45bad;">ls -a</span>
<span style="color: #a45bad;"># displays .git !</span>
<span style="color: #686868;">```</span>
</pre>
</div>

</section>
<section >

<ul>
<li>regarder le contenu du répertoire <code>.git/objects</code>, de l'index <code>.git/index</code></li>
<li>ajouter le fichier créé au suivi git, avec <code>git add</code></li>
<li>regarder le contenu du répertoire <code>.git/objects</code></li>

</ul>

<p>
Un fichier est apparu:
</p>
<ul>
<li>nom compliqué: <code>fb/cf12d50552354fc878706bacea89fbb3f9f999</code> par exemple</li>
<li>contenu compressé.</li>

<li>regarder le contenu de l'index <code>.git/index</code></li>

</ul>
<p>
Le fichier index est rempli !
</p>

</section>
<section id="slide-org334fc23">
<h3 id="org334fc23">Commandes à NE PAS retenir</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ dpkg -S zlib-flate <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">comes from qpdf</span>
$ cat .git/objects/fb/cf12d50552354fc878706bacea89fbb3f9f999 
    | zlib-flate -uncompress 
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">displays:</span>
<span style="color: #2aa1ae; background-color: #292e34;">#</span><span style="color: #2aa1ae; background-color: #292e34;">blob taille contenu initial</span>
$ git show fbcf12d
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">displays content of "blob"</span>
$ git ls-files -s <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">show contents of .git/index</span>
</pre>
</div>

</section>
<section id="slide-org7ab44dd">
<h3 id="org7ab44dd">Stockage git des fichiers</h3>
<p>
Git stocke donc le contenu des fichiers dans <code>.git/objects</code>, sous une forme
compressée.
</p>

</section>
</section>
<section>
<section id="slide-org1b6d492">
<h2 id="org1b6d492">Modèle objet de git</h2>
<ul>
<li>faites un commit, contenant le fichier <code>1_repo_creation.md</code></li>
<li>observez les changement sur <code>.git/objects</code>, sur <code>.git/index</code></li>
<li>repérez les fichiers créés, afficher le contenu</li>
<li>rédigez <code>2_add_commit.md</code></li>
<li>add, commit, observez <code>.git/objects</code></li>

</ul>

<p>
<a href="http://gamba.perso.enseeiht.fr/appliweb/git/git.html#10">en image</a>
</p>

</section>
</section>
<section>
<section id="slide-org41ec86a">
<h2 id="org41ec86a">Visualiser l'historique</h2>
<dl>
<dt><code>git status</code></dt><dd>vue de l'état du répertoire de travail par rapport à l'index
et au dernier commit</dd>
<dt><a href="https://www.atlassian.com/git/tutorials/inspecting-a-repository/git-log">git log</a></dt><dd>liste les commits précédents</dd>
<dt><code>git diff</code></dt><dd>affiche les différences entre 2 versions</dd>

</dl>

</section>
<section id="slide-orga7d3909">
<h3 id="orga7d3909">Visualiser le graphe des commits</h3>
<p>
Vous devez maintenant avoir au moins 2 commits dans votre historique.
</p>

<ul>
<li><code>git log</code> : liste des commits, le plus récent en premier</li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #4f97d7;">alias</span> <span style="color: #7590db;">gr</span>=<span style="color: #2d9574;">'git log --oneline --graph --all --decorate'</span>
gr
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">or with git</span>
git config --global alias.gr <span style="color: #2d9574;">'log --oneline --graph --all --decorate'</span>
git gr
</pre>
</div>

</section>
<section id="slide-org68206ca">
<h3 id="org68206ca">Observer les différences: git diff</h3>
<p>
<code>git diff</code> : comme la commande <code>diff</code>, mais prend en compte index et historique
</p>

<div class="org-src-container">

<pre  class="src src-shell">git diff <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">default: working copy VS index</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">test by modify a file</span>
git diff -- one_file <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">restrict to one file</span>
git diff ed123 <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">working copy VS history</span>
git diff --cached <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">index VS last commit</span>
git diff --cached ed123 <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">index VS history</span>
git diff ed123 ab321 <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">history VS history</span>
</pre>
</div>

</section>
</section>
<section>
<section id="slide-orgc624f89">
<h2 id="orgc624f89">Modification des espaces de gestion git</h2>
<p>
Rappel: 3 espaces à gérer avec git:
</p>

<ul>
<li>copie de travail, <i>working copy</i></li>
<li>zone de préparation de commit, <i>staging area</i> ou <i>index</i>.</li>
<li>historique, <i>commit graph</i> ou <i>history</i>.</li>

</ul>

</section>
<section id="slide-orgd069443">
<h3 id="orgd069443">Modifier la copie de travail</h3>
<p>
<code>git checkout</code> va modifier le contenu du répertoire de travail à partir de
l'index ou de l'historique.
</p>

<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">restore a file from index</span>
$ git checkout -- &lt;file&gt; 
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">restore a file from history</span>
$ git checkout &lt;commit&gt; -- &lt;file&gt;
</pre>
</div>

<p>
Testez par vous même: effacez un fichier avec <code>rm</code>, restaurez le depuis l'historique
</p>
</section>
<section id="slide-org9994b75">
<h3 id="org9994b75">Modifier l'index</h3>
<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">adds</span>
$ git add &lt;file&gt;
$ git add dir <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">recursive</span>
$ git add . <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">recursive</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">remove: cancel a previous add</span>
$ git reset HEAD &lt;file&gt;
</pre>
</div>

<ul>
<li><code>HEAD</code> : symbole pour «le dernier commit en date» de l'historique</li>
<li>Rappelez vous que <code>git commit</code> vide l'index courant pour fabriquer un <code>commit</code>.</li>

</ul>

</section>
<section id="slide-org1db8948">
<h3 id="org1db8948">Modifier l'historique</h3>
<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">creates a new commit from index</span>
$ git commit -m <span style="color: #2d9574;">"message in the commit"</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">open $EDITOR to edit commit message</span>
$ <span style="color: #7590db;">EDITOR</span>=my_perfect_editor git commit
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">by default, EDITOR=nano : beurk !</span>
</pre>
</div>

<p>
Positionner la variable d'environnement <code>EDITOR</code> dans votre shell pour refléter
vos préférences.
</p>

</section>
<section id="slide-orga908740">
<h3 id="orga908740">Résumé graphique</h3>

<div class="figure">
<p><img src="images/basic_commands.png" alt="basic_commands.png" />
</p>
</div>


</section>
</section>
<section>
<section id="slide-org56e34f1">
<h2 id="org56e34f1">Opérations diverses</h2>
<div class="outline-text-2" id="text-org56e34f1">
</div>
</section>
<section id="slide-org21273c1">
<h3 id="org21273c1">Effacer un fichier</h3>
<ul>
<li>du répertoire de travail ET de l'historique:</li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell"> git rm &lt;file&gt; <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">same as rm &lt;file&gt; then git add &lt;file&gt;</span>
 git status
 <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">supprim&#233;: &lt;file&gt;</span>
 git commit -m <span style="color: #2d9574;">"deleted file"</span>
</pre>
</div>

<p>
Attention: on crée dans l'historique un nouveau commit où le fichier a disparu.
Les commits précédents où le fichier existait ne sont pas modifiés !
</p>

<p>
=&gt; on ne stocke pas de données sensibles dans un dépôt git public
</p>
</section>
</section>
<section>
<section id="slide-org1f0d506">
<h2 id="org1f0d506">.gitignore</h2>
<ul>
<li>pour ignorer systématiquement des fichiers dans git</li>
<li>fichiers temporaires créés par des éditeurs</li>
<li>fichiers sensibles (mot de passe …)</li>

</ul>

<p>
Pour tous les dépôts: <code>~/.gitignore</code>
</p>

<p>
Pour un dépôt spécifique: <code>repo/.gitignore</code>, à ajouter à l'historique
</p>

<ul>
<li><a href="https://github.com/github/gitignore">collection de .gitignore</a></li>
<li><a href="https://www.atlassian.com/git/tutorials/gitignore">tuto gitignore</a></li>

</ul>

</section>
<section id="slide-orgb967b91">
<h3 id="orgb967b91">À vous</h3>
<ul>
<li>faites un <code>.gitignore</code> général correspondant à votre éditeur de texte et à vim</li>
<li>réalisez un script shell prenant un répertoire contenant des fichiers markdown en paramètre,
et retournant la version html. Exemple de base: <a href="https://gitlab.com/snippets/1847548">panki</a></li>
<li>faites un <code>.gitignore</code> dans votre dépôt pour ignorer les fichiers
correspondant à l'exécution de la commande.</li>
<li>rédigez vos notes sur le sujet au format markdown dans <code>3_gitignore.md</code></li>

</ul>

</section>
</section>
<section>
<section id="slide-org582b0ef">
<h2 id="org582b0ef">Changer TOUT le répertoire courant</h2>
<p>
Un <i>commit</i> regroupe une arborescence de fichiers à une certaine version.
</p>

<p>
Pour afficher un <i>commit</i> dans le répertoire courant:
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git checkout commit_number <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">6 characters are sufficient</span>
Vous &#234;tes dans l<span style="color: #2d9574;">'&#233;tat &#171; HEAD d&#233;tach&#233;e &#187;</span>
</pre>
</div>


<div class="figure">
<p><img src="images/nohead.jpg" alt="nohead.jpg" />
</p>
</div>

</section>
</section>
<section>
<section id="slide-org341be3c">
<h2 id="org341be3c">Branches</h2>

<div class="figure">
<p><img src="./images/conf5.png" alt="conf5.png" />
</p>
</div>

<ul>
<li>1 branche = 1 historique = 1 série de commits liés par une relation de parenté</li>
<li>travailler en // sur des versions différents</li>
<li>fusionner 2 historiques divergentes</li>

</ul>
</section>
<section >

<ul>
<li>Travail de base dans git: série de commits liés</li>
<li>Branche: un nom</li>
<li>Branche: pointe sur un commit</li>
<li>Branche: suit l'historique, pointe sur le commit le plus récent</li>
<li>à chaque nouveau commit, la branche courante est mise à jour</li>
<li>Branche par défaut: master</li>

</ul>

<p>
Le commit correspondant à une branche est stocké dans
<code>.git/objects/refs/head/nom_branche</code>
</p>

</section>
<section id="slide-orgf49e8e1">
<h3 id="orgf49e8e1">Visualiser</h3>
<ul>
<li><code>git branch</code>: liste toutes les branches, <code>*</code> devant la branche courante.</li>
<li><code>git log</code></li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #4f97d7;">alias</span> <span style="color: #7590db;">gr</span>=<span style="color: #2d9574;">'git log --oneline --graph --all --decorate'</span>
gr
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">or with git</span>
git config --global alias.gr <span style="color: #2d9574;">'log --oneline --graph --all --decorate'</span>
git gr
</pre>
</div>

</section>
<section id="slide-org4d069ef">
<h3 id="org4d069ef">Branche = raccourci vers un commit</h3>
<p>
En particulier: <code>git checkout &lt;commit&gt;|&lt;branch&gt;</code>
</p>

<p>
Cela va vous permettre par exemple:
</p>

<ol>
<li>de vous positionner sur un commit particulier: «detached HEAD»</li>
<li>vous repositionner sur le dernier commit d'une branche: <code>git checkout master</code></li>

</ol>


</section>
<section id="slide-org1526d1c">
<h3 id="org1526d1c">Exemple</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git branch
$ git checkout master
$ cat .git/refs/heads/master <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">f2fd6&#8230; : un commit</span>
$ git branch -v <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">affiche le commit</span>
$ git show f2fd6 <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">un commit !</span>
$ git log <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">le dernier commit</span>
$ echo <span style="color: #2d9574;">"## je suis branch&#233;, j'utilise git"</span> &gt;&gt; readme.md
$ git status
$ git add readme.md
$ git commit -m <span style="color: #2d9574;">"la branche bouge avec les commits"</span>
$ git log <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">c73f6 &#8230; : un nouveau commit</span>
$ cat .git/refs/heads/master <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">c73f6 &#8230; : la branche suit !</span>
</pre>
</div>

</section>
<section >

<a href="https://asciinema.org/a/O8wvrgkl2BlXigdgrpNDLavlH" target="_blank"><img src="https://asciinema.org/a/O8wvrgkl2BlXigdgrpNDLavlH.svg" /></a>
</section>
<section id="slide-org7bfe86f">
<h3 id="org7bfe86f">Branches et conventions</h3>
<dl>
<dt>branche</dt><dd>raccourci vers le dernier commit d'un historique</dd>
<dt>master</dt><dd>la branche par défaut</dd>
<dt>HEAD</dt><dd>la branche du répertoire de travail</dd>
<dt>HEAD</dt><dd>stockée dans <code>.git/HEAD</code>, contenu: un commit !</dd>
<dt><code>.git/refs/heads/*</code></dt><dd>la liste des branches</dd>

</dl>

</section>
</section>
<section>
<section id="slide-orgd08d42e">
<h2 id="orgd08d42e">Gérer plusieurs branches</h2>
<ul>
<li><code>git branch</code> affiche les branches, et la branche courante.</li>
<li><code>git branch newBranch</code> crée une nouvelle branche</li>

</ul>

<p>
Après création, la nouvelle branche référence le même commit que l'ancienne
branche.
</p>

<ul>
<li><code>git checkout newBranch</code> <i>bascule</i> sur la nouvelle branche.</li>

</ul>

<p>
Si on fait un nouveau commit, <code>newBranch</code> référencera ce nouveau commit, alors
que l'ancienne branche référencera le commit originel.
</p>

</section>
</section>
<section>
<section id="slide-org5e93846">
<h2 id="org5e93846">Où comment gérer des versions en parallèle</h2>
</section>
<section >

<div class="figure">
<p><img src="images/branch1.png" alt="branch1.png" />
</p>
</div>

</section>
<section >


<div class="figure">
<p><img src="images/branch2.png" alt="branch2.png" />
</p>
</div>

</section>
<section id="slide-org5a2e397">
<h3 id="org5a2e397">Création de branche</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git branch testing
</pre>
</div>



<div class="figure">
<p><img src="images/branch3.png" alt="branch3.png" />
</p>
</div>

</section>
<section id="slide-org8a54384">
<h3 id="org8a54384"><code>HEAD</code> branche du répertoire courant</h3>

<div class="figure">
<p><img src="images/branch4.png" alt="branch4.png" />
</p>
</div>

</section>
<section id="slide-orgd086ccf">
<h3 id="orgd086ccf">changer <code>HEAD</code></h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git checkout testing
</pre>
</div>

<div class="figure">
<p><img src="images/branch5.png" alt="branch5.png" />
</p>
</div>

</section>
<section id="slide-orgdab01fb">
<h3 id="orgdab01fb">Modifier la branche courante</h3>
<p>
faire un commit
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ echo <span style="color: #2d9574;">"change &#8230;"</span> &gt; file
$ git add file
$ git commit -m <span style="color: #2d9574;">"new commit on testing branch"</span>
</pre>
</div>


<div class="figure">
<p><img src="images/branch6.png" alt="branch6.png" />
</p>
</div>


</section>
<section id="slide-org1dea670">
<h3 id="org1dea670">Retour sur la branche initiale</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git checkout master
</pre>
</div>

<div class="figure">
<p><img src="images/branch7.png" alt="branch7.png" />
</p>
</div>

</section>
<section id="slide-orgab88263">
<h3 id="orgab88263">Commit sur la branche initiale</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ echo <span style="color: #2d9574;">"other change &#8230;"</span> &gt; file
$ git add file
$ git commit -m <span style="color: #2d9574;">"new commit on master branch"</span>
</pre>
</div>


<div class="figure">
<p><img src="images/branch8.png" alt="branch8.png" />
</p>
</div>

</section>
<section id="slide-org7fa7dd6">
<h3 id="org7fa7dd6">L'historique diverge !</h3>
<ul>
<li>maintenir plusieurs versions en parallèle
<ul>
<li>production, branche toujours utilisable</li>
<li>une branche par fonctionnalité en cours de développement</li>

</ul></li>
<li>gérer plusieurs projets dans le même dépôt: 
<ul>
<li>doc et code par exemple</li>

</ul></li>

</ul>

</section>
<section id="slide-orgca030e5">
<h3 id="orgca030e5">Merge</h3>
<div class="org-src-container">

<pre  class="src src-shell">git merge
</pre>
</div>
<ul>
<li>fusionner les changements d'une branche dans une autre</li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">se positionner sur la branche qui contiendra la fusion</span>
$ git checkout branche_resultat
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">fusionnier</span>
$ git merge other_branch
</pre>
</div>

</section>
<section id="slide-org08387e5">
<h3 id="org08387e5">Fast Forward Merge</h3>

<div class="figure">
<p><img src="images/ffmerge1.png" alt="ffmerge1.png" />
</p>
</div>

<div class="org-src-container">

<pre  class="src src-shell">$ git checkout master
$ git merge issue53
</pre>
</div>

</section>
<section >

<div class="figure">
<p><img src="images/ffmerge2.png" alt="ffmerge2.png" />
</p>
</div>

<ul>
<li>simple avancée d'étiquette, pas de commit créé</li>

</ul>
</section>
<section id="slide-orgb929912">
<h3 id="orgb929912">Classic Merge</h3>

<div class="figure">
<p><img src="images/merge1.png" alt="merge1.png" />
</p>
</div>

<ul>
<li>c2: ancêtre commun au 2 branches</li>
<li>c4: commit le plus récent de master</li>
<li>c5: commit le plus récent de iss53</li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell">$ git checkout master
$ git merge iss53
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">creates a new commit, merges c4 and c5</span>
</pre>
</div>

</section>
<section >

<div class="figure">
<p><img src="images/merge2.png" alt="merge2.png" />
</p>
</div>

<ul>
<li>nouveau commit crée, avec 2 commits parents</li>

</ul>

</section>
<section id="slide-org371093c">
<h3 id="org371093c">Conflit de merge</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git merge iss534
Auto-merging index.html
<span style="color: #bc6ec5; font-weight: bold;">CONFLICT</span> <span style="color: #4f97d7;">(</span>content<span style="color: #4f97d7;">)</span>: Merge conflict<span style="color: #4f97d7; font-weight: bold;"> in</span> index.html
Automatic merge failed; fix conflicts and then 
commit the result.

<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">cr&#233;&#233; .git/MERGE_HEAD</span>
</pre>
</div>

</section>
<section id="slide-orgcc760ed">
<h3 id="orgcc760ed">Où ?</h3>
<div class="org-src-container">

<pre  class="src src-shell">$ git status
index.html: needs merge
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">On branch master</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">Changed but not updated:</span>
<span style="color: #2aa1ae; background-color: #292e34;">#   </span><span style="color: #2aa1ae; background-color: #292e34;">(use "git add &lt;file&gt;..." to update what will </span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">be committed)</span>
<span style="color: #2aa1ae; background-color: #292e34;">#   </span><span style="color: #2aa1ae; background-color: #292e34;">(use "git checkout -- &lt;file&gt;..." to discard </span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">changes in working directory)</span>
<span style="color: #2aa1ae; background-color: #292e34;">#</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">unmerged:   index.html</span>
</pre>
</div>

</section>
<section id="slide-orgad426ca">
<h3 id="orgad426ca">Résolution</h3>
<ul>
<li>éditer le(s) fichier(s) en confilt</li>
<li>repères pour trouver le problème : <code>&lt;&lt;&lt;&lt;&lt;&lt;&lt; ... ======== .... &gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;</code></li>
<li>régler le problème, puis faites un commit normal</li>

</ul>

<div class="org-src-container">

<pre  class="src src-shell">$ git status
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">On branch master</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">Changes to be committed:</span>
<span style="color: #2aa1ae; background-color: #292e34;">#   </span><span style="color: #2aa1ae; background-color: #292e34;">(use "git reset HEAD &lt;file&gt;..." to unstage)</span>
<span style="color: #2aa1ae; background-color: #292e34;">#</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">modified:   index.html</span>
$ git commit
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">message du commit par d&#233;faut :</span>
Merge branch <span style="color: #2d9574;">'iss53'</span>

Conflicts:
  index.html
<span style="color: #2aa1ae; background-color: #292e34;">#</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">It looks like you may be committing a MERGE.</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">If this is not correct, please remove the file</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">.git/MERGE_HEAD</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">and try again.</span>
</pre>
</div>

</section>
<section id="slide-orgf31d56b">
<h3 id="orgf31d56b">En pratique</h3>
<ul>
<li><a href="https://learngitbranching.js.org">https://learngitbranching.js.org</a></li>
<li><a href="https://gitlab.com/pi.gam/tp_git_branches">tp sur les manipulations de branches sur gitlab.com</a></li>

</ul>


</section>
</section>
<section>
<section id="slide-orge21cec1">
<h2 id="orge21cec1">Lier un dépôt à un autre dépôt</h2>
<dl>
<dt><code>remote</code></dt><dd>référence un dépôt distant</dd>
<dt><code>git remote</code></dt><dd>pour manipuler</dd>

</dl>

<p>
On associe à un <i>nom</i> l'emplacement d'un répertoire <code>.git</code>
</p>

</section>
<section >
<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">cr&#233;er un autre d&#233;p&#244;t git</span>
$ cd ..; cp -r editor other_git; <span style="color: #4f97d7;">cd</span> editor 
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">r&#233;f&#233;rencer ce d&#233;p&#244;t dans le d&#233;p&#244;t courant</span>
$ git remote add other ../other_git/.git
$ git remote -v
other   ../other_git/.git <span style="color: #4f97d7;">(</span>fetch<span style="color: #4f97d7;">)</span>
other   ../other_git/.git <span style="color: #4f97d7;">(</span>push<span style="color: #4f97d7;">)</span>
$ cat .git/config
<span style="color: #4f97d7;">[</span>remote <span style="color: #2d9574;">"other"</span><span style="color: #4f97d7;">]</span>
        url = ../other_git/.git
        fetch = +refs/heads/*:refs/remotes/other/*
</pre>
</div>

</section>
<section id="slide-org65dce2d">
<h3 id="org65dce2d">Protocole d'accés à un auntre dépôt</h3>
<ul>
<li><code>url file</code> : chemin vers un <code>.git</code></li>
<li><code>url ssh</code> : <code>ssh://user@server:path/to/depot.git</code></li>
<li><code>url http[s]</code> : <code>https[s]://server/path/to/depot.git</code></li>

</ul>

<p>
Dans tous les cas: le moyen d'accéder à un <code>.git</code>
</p>

</section>
<section id="slide-org988b407">
<h3 id="org988b407">Opération de synchronisation</h3>
<ul>
<li><code>fetch</code> : récupérer en local les modifications faites sur le dépôt distant</li>
<li><code>push</code> : envoyer des modifications locales sur le dépôt distant</li>

</ul>

</section>
<section id="slide-org4ab7c3d">
<h3 id="org4ab7c3d">Fetch</h3>
<p>
<code>git fetch remoteName</code>
</p>

<p>
On copie les objets du dépôt distant dans le dépôt local
</p>

</section>
<section >

<div class="org-src-container">

<pre  class="src src-shell">$ cd ../other_git
$ echo blahblahblah &gt; test_fetch 
$ git add .
$ git commit -m <span style="color: #2d9574;">"un fichier pour 2e d&#233;p&#244;t git"</span>
$ cd ../editor <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">retour au d&#233;p&#244;t originel</span>
$ git fetch other
remote: &#201;num&#233;ration des objets: <span style="color: #a45bad;">4,</span> fait.
remote: D&#233;compte des objets: <span style="color: #a45bad;">100%</span> <span style="color: #4f97d7;">(</span><span style="color: #a45bad;">4/4</span><span style="color: #4f97d7;">)</span>, fait.
remote: Compression des objets: <span style="color: #a45bad;">100%</span> <span style="color: #4f97d7;">(</span><span style="color: #a45bad;">2/2</span><span style="color: #4f97d7;">)</span>, fait.
remote: Total <span style="color: #a45bad;">3</span> <span style="color: #4f97d7;">(</span>delta <span style="color: #a45bad;">0</span><span style="color: #4f97d7;">)</span>, r&#233;utilis&#233;s <span style="color: #a45bad;">0</span> <span style="color: #4f97d7;">(</span>delta <span style="color: #a45bad;">0</span><span style="color: #4f97d7;">)</span>
D&#233;paquetage des objets: <span style="color: #a45bad;">100%</span> <span style="color: #4f97d7;">(</span><span style="color: #a45bad;">3/3</span><span style="color: #4f97d7;">)</span>, fait.
Depuis ../other_git/
   c1fd818..7a00391  master     -&gt; other/master
</pre>
</div>

</section>
<section >

<div class="org-src-container">

<pre  class="src src-shell">$ cd ../other_git
$ git checkout -b stuff
$ echo stuff &gt;&gt; stuff
$ git add stuff; git commit -m <span style="color: #2d9574;">"stuff !"</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">orginal repo</span>
$ cd ../editor
$ git fetch other
&#8230;
Depuis ../other_git/
 * <span style="color: #4f97d7;">[</span>nouvelle branche<span style="color: #4f97d7;">]</span> stuff      -&gt; other/stuff
</pre>
</div>

<ul>
<li>Les branches du dépôt distant sont copiées en local</li>
<li>référencées dans <code>.git/refs/remotes/remote_name/…</code></li>

</ul>

</section>
<section id="slide-orgb5bce6f">
<h3 id="orgb5bce6f">Les branches «distantes» sont … locales !</h3>
<p>
La copie locale d'une branche d'un dépôt distant s'appelle
<code>RemoteName/branchName</code>, par ex <code>other/master</code> dans notre exemple.
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ tree .git/refs                                        
.git/refs
&#9500;&#9472;&#9472; heads
&#9474;&#160;&#160; &#9492;&#9472;&#9472; master
&#9500;&#9472;&#9472; remotes
&#9474;&#160;&#160; &#9492;&#9472;&#9472; other
&#9474;&#160;&#160;     &#9492;&#9472;&#9472; master
&#9492;&#9472;&#9472; tags
$ git branch -a <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">pour afficher les branches &#171;distantes&#187;      </span>
x master
  remotes/other/master
  remotes/other/stuff
</pre>
</div>

</section>
<section id="slide-org87d8c0d">
<h3 id="org87d8c0d">Appliquer des changements</h3>
<p>
La copie de la branche distance est une branche local.
</p>

<p>
<code>git diff</code>, <code>git merge</code> vous permettent donc de fusionner comme on a déjà vu, en
utilisant <code>RemoteName/branchName</code> comme nom de commit.
</p>

<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">after git fetch other</span>
git diff other/master
git merge other/master
</pre>
</div>

</section>
<section id="slide-org06746fd">
<h3 id="org06746fd">Travailler sur une copie locale d'une branche distante</h3>
<p>
On ne peut travailler directement sur une branche <code>remote/…</code>.
</p>

<p>
On crée une branche locale <i>liée</i> à une branche <code>remote</code>.
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git checkout -b stuff other/stuff <span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">checkout -b = cr&#233;e branche puis bascule dessus</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">=&gt; cr&#233;e la branche locale stuff, li&#233;e &#224; la branche distante other/stuff</span>
$ echo <span style="color: #2d9574;">"new content"</span> &gt; readme.md
$ git add .
$ git commit -m <span style="color: #2d9574;">"push !"</span>
</pre>
</div>

</section>
<section id="slide-org8a1e35a">
<h3 id="org8a1e35a">push</h3>
<p>
copier les modifications de la <b>branche locale</b> dans un dépôt distant sur une
<b>branche distante</b>
</p>

<p>
<code>git push remoteName remoteBranchName</code>
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git push other master
</pre>
</div>

<p>
Attention: ce n'est pas le symétrique de <code>fetch</code>
</p>
</section>
</section>
<section>
<section id="slide-orge2a37eb">
<h2 id="orge2a37eb">Workflow distant simplifié</h2>
<p>
On verra la version complète dans la seance 2.
</p>

<div class="org-src-container">

<pre  class="src src-shell">$ git clone remote_url
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">remote_url : file, ssh, http[s]</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">remote origin is automatically created</span>
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">work and commit localy</span>
$ git add &#8230;
$ git commit &#8230;
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">push local modification to original repository</span>
$ git push origin master
</pre>
</div>

<ul>
<li>branche <code>remote</code> : référence un dépôt distant</li>
<li><code>git remote</code> : pour manipuler</li>
<li><code>git clone git_url</code> : initialiser un dépôt git à partir d'un dépôt distant
existant, branche remote <code>origin</code> par défaut</li>

</ul>

</section>
<section id="slide-orge9ac501">
<h3 id="orge9ac501">Workflow</h3>
<dl>
<dt><code>git fetch remote_name remote_branch</code></dt><dd>rapatrie en local les modifications d'un dépôt distant</dd>
<dt><code>git branch -r</code></dt><dd>affiche les branches distantes</dd>
<dt><code>git pull remote_name remote_branch</code></dt><dd><code>fetch</code> puis <code>merge</code></dd>
<dt><code>git push remote_name remote_branch</code></dt><dd>transfère (pousse) les nouveautés de la branche
locale au dépôt distant.</dd>

</dl>

<p>
<a href="https://www.atlassian.com/git/tutorials/syncing">synchronisation local/distant</a>
</p>

</section>
<section id="slide-org56632aa">
<h3 id="org56632aa">Bare repository</h3>
<p>
dépot git:
</p>

<ul>
<li>répertoire de travail, branche <code>HEAD</code></li>
<li>préparation d'un commit, index/stagin area</li>
<li><code>.git</code> : branches et objets</li>

</ul>

<p>
dépôt «bare» (nu):
</p>

<ul>
<li>uniquement le contenu du <code>.git</code></li>

</ul>

<p>
Ce type de dépôt sert pour la synchronisation à distance.
</p>

</section>
</section>
<section>
<section id="slide-org2feb2ce">
<h2 id="org2feb2ce">Github/gitlab/bitbucket</h2>
<p>
Interfaces web autour de dépôt git «bare»
</p>

<p>
présentation des outils
</p>

</section>
<section id="slide-org36f881d">
<h3 id="org36f881d">TP</h3>
<ul>
<li>créez un projet sur <a href="https://gitlab.com">https://gitlab.com</a>, après avoir créé un compte.</li>
<li>assurez vous d'avoir <a href="https://docs.gitlab.com/ee/ssh/">généré une paire de clefs ssh</a></li>
<li>créer un projet sur gitlab</li>
<li>rajouter une référence au dépôt distant gitlab sur votre dépôt local, appelée <code>gitlab</code></li>

</ul>
<div class="org-src-container">

<pre  class="src src-shell">$ git remote add gitlab git@gitlab.com:/your_gitlab_nick/your_project.git
</pre>
</div>
<ul>
<li>«Pousser» chaque branche locale sur le dépôt distant:</li>

</ul>
<div class="org-src-container">

<pre  class="src src-shell">$ git branch
$ git push branch_name gitlab branch_name
</pre>
</div>

</section>
<section >
<ul>
<li>cloner le dépôt distant à un autre endroit</li>

</ul>
<div class="org-src-container">

<pre  class="src src-shell">$ git clone git@gitlab.com:/your_gitlab_nick/your_project.git
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">create your_project directory</span>
$ cd your_project
$ git remote -v
origin git@gitlab.com:/your_gitlab_nick/your_project.git <span style="color: #4f97d7;">(</span>fetch<span style="color: #4f97d7;">)</span>
origin git@gitlab.com:/your_gitlab_nick/your_project.git <span style="color: #4f97d7;">(</span>push<span style="color: #4f97d7;">)</span>
</pre>
</div>
<ul>
<li>faites un commit en local, poussez le sur gitlab:</li>

</ul>
<div class="org-src-container">

<pre  class="src src-shell"><span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">in the 2nd copy</span>
<span style="color: #4f97d7;">echo</span> <span style="color: #2d9574;">"pouet"</span> &gt; pouet.md
git add pouet.md; git commit -m <span style="color: #2d9574;">"pouet !"</span>
git push origin master

<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">back to fist repo</span>
<span style="color: #4f97d7;">cd</span> &#8230;/old_repo
git fetch gitlab
<span style="color: #2aa1ae; background-color: #292e34;"># </span><span style="color: #2aa1ae; background-color: #292e34;">news on master branch</span>
git merge gitlab/master
</pre>
</div>

</section>
</section>
<section>
<section id="slide-org05a3f8d">
<h2 id="org05a3f8d">Conclusion de la formation</h2>
<ul>
<li>vous devriez en savoir assez pour travailler seul</li>
<li>2e partie de la formation: comment travailler à plusieurs …</li>

</ul>

<p>
=&gt; TODO
</p>
<ul>
<li>pratiquer git, faites des branches en local !</li>
<li>pratiquer markdown</li>
<li>pratiquer gitlab/github</li>

</ul>

</section>
<section id="slide-orgbf31fbf">
<h3 id="orgbf31fbf">Ressources</h3>
<ul>
<li><a href="https://git-scm.com/book/fr/v2">git book, VF</a></li>
<li><a href="https://marklodato.github.io/visual-git-guide/index-en.html">visual git guide</a></li>
<li><a href="https://learngitbranching.js.org">learngitbranching.js</a></li>
<li><a href="https://www.atlassian.com/git/tutorials">tutoriaux Atlassian</a></li>

</ul>
</section>
</section>
</div>
</div>
<script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/lib/js/head.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/js/reveal.js"></script>

<script>
// Full list of configuration options available here:
// https://github.com/hakimel/reveal.js#configuration
Reveal.initialize({

controls: true,
progress: true,
history: false,
center: false,
slideNumber: 'c',
rollingLinks: false,
keyboard: true,
overview: true,
margin: 0.01,

theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
transition: Reveal.getQueryHash().transition || 'none', // default/cube/page/concave/zoom/linear/fade/none
transitionSpeed: 'default',
multiplex: {
    secret: '', // null if client
    id: '', // id, obtained from socket.io server
    url: '' // Location of socket.io server
},

// Optional libraries used to extend on reveal.js
dependencies: [
 { src: 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/lib/js/classList.js', condition: function() { return !document.body.classList; } },
 { src: 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
 { src: 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
 { src: 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
 { src: 'https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.8.0/plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }]
});
</script>
</body>
</html>
